bm::sv_addr_resolver< SV > Class Template Reference

sparse vector based address resolver (no space compactor, just bit-plane compressors provided by sparse_vector) More...

`#include <bmsparsevec_util.h>`

## Public Types

typedef SV | sparse_vector_type
typedef SV::bvector_type | bvector_type
typedef bvector_type::size_type | size_type

## Public Member Functions

| sv_addr_resolver ()
| sv_addr_resolver (const sv_addr_resolver &addr_res)
bool | resolve (size_type id_from, size_type *id_to) const
| Resolve id to integer id (address).
bool | get (size_type id_from, size_type *id_to) const
| Resolve id to integer id (address).
void | set (size_type id_from)
| Set id (bit) to address resolver.
void | optimize (bm::word_t *temp_block=0)
| optimize underlying sparse vectors
const bvector_type & | get_bvector () const
| Get const reference to the underlying bit-vector of set values.

## Detailed Description

template<class SV>
class bm::sv_addr_resolver< SV >

sparse vector based address resolver (no space compactor, just bit-plane compressors provided by sparse_vector)

Definition at line 169 of file bmsparsevec_util.h.

## Member Typedef Documentation

## bvector_type

template<class SV>

typedef SV::bvector_type bm::sv_addr_resolver< SV >::bvector_type

Definition at line 173 of file bmsparsevec_util.h.

## size_type

template<class SV>

typedef bvector_type::size_type bm::sv_addr_resolver< SV >::size_type

Definition at line 174 of file bmsparsevec_util.h.

## sparse_vector_type

template<class SV>

typedef SV bm::sv_addr_resolver< SV >::sparse_vector_type

Definition at line 172 of file bmsparsevec_util.h.

## Constructor & Destructor Documentation

## sv_addr_resolver() [1/2]

template<class SV>

bm::sv_addr_resolver< SV >::sv_addr_resolver | ( |  | ) |

Definition at line 547 of file bmsparsevec_util.h.

Referenced by sv_addr_resolver().

## sv_addr_resolver() [2/2]

template<class SV>

bm::sv_addr_resolver< SV >::sv_addr_resolver | ( | const sv_addr_resolver< SV > & | addr_res | ) |

Definition at line 556 of file bmsparsevec_util.h.

References sv_addr_resolver().

## Member Function Documentation

## get()

template<class SV>

bool bm::sv_addr_resolver< SV >::get | ( | size_type | id_from,
|  | size_type * | id_to ) const

Resolve id to integer id (address).

Parameters

  id_from | - input id to resolve
  id_to | - output id

Returns
  true if id is known and resolved successfully

## get_bvector()

template<class SV>

const bvector_type & bm::sv_addr_resolver< SV >::get_bvector | ( |  | ) | const

inline

Get const reference to the underlying bit-vector of set values.

Definition at line 212 of file bmsparsevec_util.h.

## optimize()

template<class SV>

void bm::sv_addr_resolver< SV >::optimize | ( | bm::word_t * | temp_block = 0 | ) |

optimize underlying sparse vectors

Definition at line 592 of file bmsparsevec_util.h.

## resolve()

template<class SV>

bool bm::sv_addr_resolver< SV >::resolve | ( | size_type | id_from,
|  | size_type * | id_to ) const

Resolve id to integer id (address).

Parameters

  id_from | - input id to resolve
  id_to | - output id

Returns
  true if id is known and resolved successfully

Definition at line 566 of file bmsparsevec_util.h.

References BM_ASSERT.

## set()

template<class SV>

void bm::sv_addr_resolver< SV >::set | ( | size_type | id_from | ) |

Set id (bit) to address resolver.

Definition at line 578 of file bmsparsevec_util.h.

The documentation for this class was generated from the following file:

- bmsparsevec_util.h